<?php
class NotificationRequest {
    public $notificationItems; 
    public $live; 
}

class NotificationRequestItem {
    public $amount;
    public $eventCode;
    public $eventDate;
    public $merchantAccountCode;
    public $merchantReference;
    public $originalReference;
    public $pspReference;
    public $reason;
    public $success;
    public $paymentMethod;
    public $operations;
    public $additionalData;
}

class Amount {
    public $currency;
    public $value;
}

class Adyen
{
	public $payed=0;
	public $sendMail=0;
	public $merchantReference;
	public $mail_data;

	function sendNotification($request)
	{
	  if (is_array($request->notification->notificationItems->NotificationRequestItem)) {
		foreach( $request->notification->notificationItems->NotificationRequestItem as $item) {
		  self::storeItem($item);
		}
	  } else {
		$item = $request->notification->notificationItems->NotificationRequestItem;
		self::storeItem($item);
	  }
	
	  return array("notificationResponse" => "[accepted]");
	}
	function storeItem($item)
	{ 	
		$this->payed='testbas';	
	  $output = $output . "\nNotification: \n" . 
		"Amount = " . $item->amount->currency . " " . $item->amount->value . "\n" .
		"Event Code = " . $item->eventCode . "\n" .
		"Event Date = " . $item->eventDate . "\n" .
		"Merchant Account Code = " . $item->merchantAccountCode . "\n" .
		"Merchant Reference = " . $item->merchantReference . "\n" .
		"Original Reference = " . $item->originalReference . "\n" .
		"Psp Reference = " . $item->pspReference . "\n" .
		"Reason = " . $item->reason . "\n" .
		"Success = " . $item->success . "\n".
		"Payment Method = " . $item->paymentMethod . "\n\n".
		
		"Available Operations: \n";
	
		if(is_array($item->operations->string)) {
		  foreach($item->operations->string as $operation) {
			$output = $output . "\t" . $operation . "\n" ;
		  }
		} else {
		  $output = $output . "\t" . $item->operations->string . "\n" ;
		}
	
		$output = $output . "\n\nAdditional Data:\n";
		if(is_array($item->additionalData->entry)) {
		  foreach($item->additionalData->entry as $entry) {
			$output = $output . "\t" . $entry->key ."=".$entry->value."\n" ;
		  }
		} else {
		  $output = $output . "\t" . $item->additionalData->entry->key ."=".$item->additionalData->entry->value."\n" ;
		}
	
		$output = $output . "\n";
		
		$merchantReference = str_replace('SKINTEST-', '', $item->merchantReference);
		$adyen_status_success	= '16';
		$adyen_status_failed	= '17';
		$adyen_status_cancelled	= '18';
		
		$mail_data = '';
		if ($item->eventCode == 'AUTHORISATION' && $item->success)
		{		
			$this->payed=1;	
			$this->merchantReference=$merchantReference;
			//		mslib_fe::updateOrderStatusToPayed($merchantReference);				
			if (file_exists($_SERVER['DOCUMENT_ROOT'].'/typo3temp/mailer_'.$merchantReference.'.ser')) {
				$mail_data = mslib_fe::file_get_contents($_SERVER['DOCUMENT_ROOT'].'/typo3temp/mailer_'.$merchantReference.'.ser');
				if ($mail_data) {
					$this->mail_data=$mail_data;
					
				}
			}
			
			
			
		} else if ($item->eventCode == 'AUTHORISATION' && !$item->success) {
			
		} else if ($item->eventCode == 'CANCELLATION' && $item->success) {
			
		}
	}
}
?>