<?php
require_once t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/klarna/Klarna.php';

//Dependencies from http://phpxmlrpc.sourceforge.net/
require_once t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/klarna/transport/xmlrpc-3.0.0.beta/lib/xmlrpc.inc';
require_once t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/klarna/transport/xmlrpc-3.0.0.beta/lib/xmlrpc_wrappers.inc';

/**
 * 1. Initialize and setup the Klarna instance.
 */

$k = new Klarna();

//Later we define the settings in code, thus we don't save the config to a file in JSON format.
KlarnaConfig::$store = false;

//Create the config object, since we aren't storing the file, we don't need to specify a URI.
$config = new KlarnaConfig($file = null);

//Define the values:
$config['eid'] = $vars['store_id']; //Merchant ID or Estore ID, an integer above 0.
$config['secret'] = $vars['shared_secret']; //The shared secret which accompanied your eid.

switch ($vars['shop_country_code']) {
	case 'DK':
		$klarna_country_code = 59;
	break;
	
	case 'FI':
		$klarna_country_code = 73;
	break;
	
	case 'DE':
		$klarna_country_code = 81;
	break;
	
	case 'NL':
		$klarna_country_code = 154;
	break;
	
	case 'NO':
		$klarna_country_code = 164;
	break;
	
	case 'SE':
		$klarna_country_code = 209;
	break;
}

switch ($vars['shop_language_code']) {
	case 'DA':
		$klarna_language_code = 27;
		break;

	case 'FI':
		$klarna_language_code = 37;
		break;

	case 'DE':
		$klarna_language_code = 28;
		break;

	case 'NL':
		$klarna_language_code = 101;
		break;

	case 'NB':
		$klarna_language_code = 97;
		break;

	case 'SV':
		$klarna_language_code = 138;
		break;
	
	case 'EN':
		$klarna_language_code = 31;
		break;
}

switch ($ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3']) {
	case 'SEK':
		$klarna_currency_code = 0;
		break;

	case 'NOK':
		$klarna_currency_code = 1;
		break;

	case 'EUR':
		$klarna_currency_code = 2;
		break;

	case 'DKK':
		$klarna_currency_code = 3;
		break;
}

$config['country'] = $klarna_country_code;
$config['language'] = $klarna_language_code;
$config['currency'] = $klarna_currency_code;

if ($vars['test']=='true') {
	$config['mode'] = Klarna::BETA; //or Klarna::BETA, depending on which server your eid is associated with.
} else {
	$config['mode'] = Klarna::LIVE;
}

//Define pclass settings:
$config['pcStorage'] = 'json'; //Which storage module? can be json, xml or mysql.
$config['pcURI'] = $vars['pclass_json_path'].'pclasses.json'; //Where the json file for the pclasses are stored.

//Should we use HTTPS?
$config['ssl']  = false;

//Should we error report/status report to Klarna?
$config['candice'] = true; //(set to false if your server doesn't support UDP)

//Do we want to see xmlrpc debugging information?
$config['xmlrpcDebug'] = false; //If this is defined to anything, it will debug.

//Do we want to see normal debug information?
$config['debug'] = false; //If this is defined to anything, it will debug.

//Set the config object.
$k->setConfig($config);
?>
