<?php
class wapBilling
{
	
	function __construct()
	{
		//nothing here
	}
	
	/*
	 * This function will handle the paymentrequest.
	 * The function will validate the array values and handles the request.
	 * If Targetpay created the payment and created the orderlink the script
	 * will sent the customer through.
	 * 
	 * Targetpay could response in three different ways:
	 * - The payment was created; The customer will be sent to the order-url which is given by Targetpay
	 * - There was an error while creating a payment; You will see the error
	 * - There will be a notice that "check" was "true" and the request should be created if "check" was "false" (other words, the script is in test modus)
	 */
	public function initiateTransaction($transaction, $order)
	{
		if(!is_array($transaction))
		{
			echo 'The transaction wasn\'t an array';
			return false;
		}
		
		
		$transaction["ip"] 	= $_SERVER["REMOTE_ADDR"];
		$error 				= $this->validateValues($transaction);

		if(count($error))
		{
			foreach($error AS $error)
			{
				$ct .= $error.'<br/>';
			}
			echo $ct;
			return false;
		}
		
		$url 	= $this->makeStartLink($transaction);
		$resp 	= $this->request($url);
		
		list($code,$extra) = explode(" ",$resp);

		if ($code == "000000")
		{
			list($transactionId, $orderUrl) = explode("|",$extra);
			
			mslib_fe::createPaymentTransactionId($order['orders_id'],'targetpay-mobilecontentbilling',$order['payment_method'], 'manual', $transactionId);
			
			header("Location: " . $orderUrl);
			die();
		}
		else
		{
			die($resp);
		}
	
	}


	/*
	 * This function will check the payment if the COMPLETE payment is done
	 */
	public function checkPayment($rtlo, $trxid, $once = false)
	{
		$url 	= $this->generateCheckUrl($rtlo, $trxid, $once);
		$resp 	= $this->request($url);
		
		list($statusCode, $message) = explode(" ",$resp);
		
		if($statusCode == "00000")
		{
			$once 	= true; //Targetpay zet de transactie op "gecontroleerd" waardoor men de link (en de content) niet kan delen.
			$url 	= $this->generateCheckUrl($rtlo, $trxid, $once);
			$resp 	= $this->request($url);
			return true;
		}
		else
		{
			return false;
		}
	}


	/*private functions*/
	
	/*
	 * Generate the checkpayment url
	 */
	private function generateCheckUrl($rtlo, $trxid, $once = false)
	{
		$link = "https://www.targetpay.com/wap/checktransaction.php5?rtlo=".urlencode($rtlo)."&trxid=".urlencode($trxid)."&once=".urlencode($once);
		return $link;
	}
	
	
	/*
	 * Validate the transactionvalues
	 */
	private function validateValues($transaction)
	{
		$error = array();
		$freqArray = array("nonsubscription","day","week","biweek","month");
		
		if(empty($transaction["service"]))
		{
			$error[] = 'No service given in';
		}
		else if(!is_numeric($transaction["service"]))
		{
			$error[] = 'The given service isn\'t numeric';
		}
		if($transaction["description"] && (strlen($transaction["description"]) >= 256))
		{
			$error[] = 'The given description is larger than 255 tekens';
		}
		if($transaction["amount"] && (($transaction["amount"] < 25) || ($transaction["amount"] > 1000)))
		{
			$error[] = 'The given amount is not between 25 and 1000';
		}
		if($transaction["returnurl"] && ((strpos($transaction["returnurl"],"http://") === false) && (strpos($transaction["returnurl"],"https://") === false)))
		{
			$error[] = 'The given returnurl doesn\'t start with "http://" or "https://"';
		}
		if($transaction["notifyurl"] && ((strpos($transaction["notifyurl"],"http://") === false) && (strpos($transaction["notifyurl"],"https://") === false)))
		{
			$error[] = 'The given notifyurl doesn\'t start with "http://" or "https://"';
		}
		if($transaction["cancelurl"] && ((strpos($transaction["cancelurl"],"http://") === false) && (strpos($transaction["cancelurl"],"https://") === false)))
		{
			$error[] = 'The given cancelurl doesn\'t start with "http://" or "https://"';
		}
		return $error;
	}

	/*
	 * Generate the transactionrequest url
	 */
	private function makeStartLink($transaction)
	{
		$link = "https://www.targetpay.com/wap/start.php5?";
		foreach($transaction AS $param => $value)
		{
			if($value)
			{
				//url encode is essentieel
				$link .= $param."=".urlencode($value)."&";
			}
		}
		return substr($link, 0, -1);
	}
	
	/*
	 * Execute the request url by doing a cURL execution
	 */
	private function request($url)
	{
		$ch = curl_init();
		if(strpos($url,"https://") !== false)
		{
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); 
		}
		curl_setopt($ch, CURLOPT_HTTPHEADER,     array('Content-Type: text/xml;charset=utf-8'));
		curl_setopt($ch, CURLOPT_URL,            $url);
		curl_setopt($ch, CURLOPT_TIMEOUT, 		  30);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$resp = curl_exec($ch);
		curl_close($ch);
		
		return $resp;
	}
}
?>
