<?php
/*
stripe.com
*/
$amount	= (preg_replace("/^0/",'',$order['total_amount']));

if ($post['stripeToken']) {
	$transaction_id=mslib_fe::createPaymentTransactionId($order['orders_id'],'stripe',$order['payment_method'], 'short_md5');
	require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/stripe/Stripe.php');
	
	// get the credit card details submitted by the form
	$token = $post['stripeToken'];
	
	// set your secret key: remember to change this to your live secret key in production
	// see your keys here https://manage.stripe.com/account
	Stripe::setApiKey($vars['secret_key']);
	
	// create the charge on Stripe's servers - this will charge the user's card
	$charge = Stripe_Charge::create(array(
			"amount" => ($amount * 100), // amount in cents, again
			"currency" => 'usd', //$ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'],
			"card" => $token,
			"description" => 'transaction_id: '.$transaction_id)
	);
	
	$orders_id=mslib_fe::getOrdersIdByTransactionId($transaction_id,'stripe');
	if ($orders_id)
	{
		mslib_fe::updateOrderStatusToPayed($orders_id);
		header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));
		exit();
	}
	
} else {
	$content .= '
	<script type="text/javascript" src="https://js.stripe.com/v1/"></script>
	<script type="text/javascript">
	            // this identifies your website in the createToken call below
	            Stripe.setPublishableKey(\''.$vars['publishable_key'].'\');
	
	            function stripeResponseHandler(status, response) {
	                if (response.error) {
	                    // re-enable the submit button
	                    jQuery(\'.submit-button\').removeAttr("disabled");
	                    // show the errors on the form
	                    jQuery(".payment-errors").html(response.error.message);
	                } else {
	                    var forms = jQuery("#payment-form");
	                    // token contains id, last4, and card type
	                    var token = response[\'id\'];
	                    // insert the token into the form so it gets submitted to the server
	                    forms.append("<input type=\'hidden\' name=\'stripeToken\' value=\'" + token + "\' />");
	                    // and submit
	                    forms.get(0).submit();
	                }
	            }
	
	            jQuery(document).ready(function() {
	                jQuery("#payment-form").submit(function(event) {
	                    // disable the submit button to prevent repeated clicks
	                    jQuery(\'.submit-button\').attr("disabled", "disabled");
	                    var chargeAmount = '.($amount*100).'; //amount you want to charge, in cents. 1000 = $10.00, 2000 = $20.00 ...
	                    // createToken returns immediately - the supplied callback submits the form if there are no errors
	                    Stripe.createToken({
	                        number: jQuery(\'.card-number\').val(),
	                        cvc: jQuery(\'.card-cvc\').val(),
	                        exp_month: jQuery(\'.card-expiry-month\').val(),
	                        exp_year: jQuery(\'.card-expiry-year\').val()
	                    }, chargeAmount, stripeResponseHandler);
	                    return false; // submit from callback
	                });
	            });
	
	            if (window.location.protocol === \'file:\') {
	                alert("stripe.js does not work when included in pages served over file:// URLs. Try serving this page over a webserver. Contact support@stripe.com if you need assistance.");
	            }
	        </script>
	
	<span class="payment-errors"></span>
	        <form action="" method="POST" id="payment-form">
	            <div class="form-row">
	                <label>Card Number</label>
	                <input type="text" size="20" autocomplete="off" class="card-number" />
	            </div>
	            <div class="form-row">
	                <label>CVC</label>
	                <input type="text" size="4" autocomplete="off" class="card-cvc" />
	            </div>
	            <div class="form-row">
	                <label>Expiration (MM/YYYY)</label>
	                <input type="text" size="2" class="card-expiry-month"/>
	                <span> / </span>
	                <input type="text" size="4" class="card-expiry-year"/>
	            </div>
	            <button type="submit" class="submit-button">Submit Payment</button>
	        </form>';
}
?>